#include <stdio.h>
#include <kallisti/libk.h>
#include <kallisti/abi/fs.h>
#include <kallisti/abi/video.h>
#include <kallisti/abi/maple.h>
#include <kallisti/abi/ta.h>
#include "image.h"
#include "filelist.h"

/* Library handles */
abi_fs_t    *fs = NULL;
abi_video_t *video = NULL;
abi_maple_t *maple = NULL;
abi_ta_t	*ta = NULL;


int main()
{
    cont_cond_t cond;
    float zoom2=0.0f, zoom=0.0f, x1=0.0f,y1=0.0f;
	int x,bifilt;
	image img;

    fs = lib_open("fs");
    if (fs == NULL) { return -1; }
    video = lib_open("video");
    if (video == NULL) { return -1; }
        video->set_mode(video->check_cable(), DM_640x480, PM_RGB565);
    maple = lib_open("maple");
    if (maple == NULL) { return -1; }
    ta = lib_open("ta");
    if (ta == NULL) { return -1; }
    
	ta->txr_release_all();

    JPEG_to_image("/rd/rusty.jpg", &img);
    
    while(1) {

        if (maple->cont_get_cond(maple->first_controller(), &cond) < 0)
            break;
        
        if (!(cond.buttons & CONT_START))
            break;
            
        if( !(cond.buttons & CONT_A))
        	zoom+=5.0f;
        	
        if( !(cond.buttons & CONT_B))
        	zoom+=-5.0f;
        	
        if( !(cond.buttons & CONT_X)){
        	zoom=0.0f;
        	zoom2=1.0f;
        	x1=0.0f;
        	y1=0.0f;
        }
        	      	
        if( !(cond.buttons & CONT_DPAD_UP))
        	y1-=1.0f;
        
        if( !(cond.buttons & CONT_DPAD_DOWN))
        	y1+=1.0f;
        	
        if( !(cond.buttons & CONT_DPAD_LEFT))
        	x1-=1.0f;
        	
        if( !(cond.buttons & CONT_DPAD_RIGHT))
        	x1+=1.0f;
        if( cond.ltrig>5)
        	zoom+=30*cond.ltrig/256;
        if( cond.rtrig>5)
        	zoom-=30*cond.rtrig/256;
        if( cond.joyx-128>5 || cond.joyx-128<-5)
        	x1+=30*(cond.joyx-128)/128;
        if( cond.joyy-128>5 || cond.joyy-128<-5)
        	y1+=30*(cond.joyy-128)/128;
    if( !(cond.buttons & CONT_Y)){
		bifilt=1;
	}else{
		bifilt=0;
	}
        	
        	
	ta->begin_render();

	draw_image(0+x1,480+y1, 300+zoom, 300+zoom, bifilt, &img);
	ta->commit_eol();

	{
		poly_hdr_t	hdr;
		ta->poly_hdr_col(&hdr, TA_TRANSLUCENT);
		ta->commit_poly_hdr(&hdr);
		ta->commit_eol();
	}

	ta->finish_frame();

    }

    return 0;
}
